#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LOGIN_CL "/home/nmatsuna/login.cl"
#define FILE_LENGTH 80

void usage(char *command);
void copy_login_cl(void);
void do_imarith(char *input1, char *op, char *input2, char *output);

int main(int argc, char *argv[]){
   FILE *fp;
   char *directory, *bias, *flat, *tail, *command;
   char file[FILE_LENGTH], new_file[FILE_LENGTH], tmp_file[]="kadai1_tmp.fits";

   if(argc!=4) usage(argv[0]);
   directory=argv[1];
   if(directory[strlen(directory)-1]=='/') directory[strlen(directory)-1]='\0';
   bias=argv[2];
   flat=argv[3];

   command=malloc((strlen(directory)+20)*sizeof(char));
   sprintf(command,"ls -1 %s/*.fits",directory);
   if( (fp=popen(command, "r")) == NULL) {
      fprintf(stderr,"failure : %s\n",command);
      exit(1);
   }
   free(command);

   while( fscanf(fp,"%s",file) == 1 ) {
      if(strstr(file,"flat")!=NULL||strstr(file,"bias")!=NULL) continue;
      strcpy(new_file,file);
      tail=strstr(new_file,".fits");
      sprintf(tail,"b.fits");
      do_imarith(file,"-",bias,tmp_file);
      do_imarith(tmp_file,"/",flat,new_file);
      remove(tmp_file);
   }
   pclose(fp);

   return 0;
}

void usage(char *command){
   fprintf(stderr, "usage -> %s  [directory]  [bias]  [flat]\n",command);
   exit(1);
}

void copy_login_cl(void){
   char *command;
   command=malloc((strlen(LOGIN_CL)+15)*sizeof(char));
   sprintf(command,"cp -rp %s .",LOGIN_CL);
   system(command);
   free(command);
}

void do_imarith(char *input1, char *op, char *input2, char *output){
   char cl_file[]="cl_sample4", log_file[]="log_sample4", command[80];
   FILE *fp;
   if((fp=fopen(cl_file,"w"))==NULL){
      fprintf(stderr,"Failed to open %s\n",cl_file);
      exit(1);
   }
   fprintf(fp,"images\n");
   fprintf(fp,"imutil\n");
   fprintf(fp,"imarith %s %s %s %s\n",input1,op,input2,output);
   fprintf(fp,"logout\n");
   fclose(fp);
   copy_login_cl();
   sprintf(command,"cl -old < %s > %s",cl_file,log_file);
   system(command);
}

