#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define LOGIN_CL "/home/nmatsuna/login.cl"

void usage(char *command);
void copy_login_cl(void);
void do_imarith(char *input1, char *op, char *input2, char *output);

int main(int argc, char *argv[]){
   char *input1, *op, *input2, *output;
   if(argc!=5) usage(argv[0]);
   input1=argv[1];
   op=argv[2];
   input2=argv[3];
   output=argv[4];
   do_imarith(input1,op,input2,output);
   return 0;
}

void usage(char *command){
   fprintf(stderr, "usage -> %s  [input1.fits]  [operator]  [input2.fits]  [output.fits] \n",command);
   exit(1);
}

void copy_login_cl(void){
   char *command;
   command=malloc((strlen(LOGIN_CL)+15)*sizeof(char));
   sprintf(command,"cp -rp %s .",LOGIN_CL);
   system(command);
   free(command);
}

void do_imarith(char *input1, char *op, char *input2, char *output){
   char cl_file[]="cl_sample4", log_file[]="log_sample4", command[80];
   FILE *fp;
   if((fp=fopen(cl_file,"w"))==NULL){
      fprintf(stderr,"Failed to open %s\n",cl_file);
      exit(1);
   }
   fprintf(fp,"images\n");
   fprintf(fp,"imutil\n");
   fprintf(fp,"imarith %s %s %s %s\n",input1,op,input2,output);
   fprintf(fp,"logout\n");
   fclose(fp);
   copy_login_cl();
   sprintf(command,"cl -old < %s > %s",cl_file,log_file);
   system(command);
}

